/* abi_xc_vdw.h */

/*
 * Copyright (C) 2012 ABINIT Group (Yann Pouillon)
 *
 * This file is part of the ABINIT software package. For license information,
 * please see the COPYING file in the top-level directory of the ABINIT source
 * distribution.
 *
 */

#ifndef _ABINIT_XC_VDW_H
#define _ABINIT_XC_VDW_H

#include "abi_common.h"

/* Error handler for VDWXC NetCDF calls */
#define NETCDF_VDWXC_DECLARE integer :: ncerr
#ifdef HAVE_FC_LONG_LINES
#define NETCDF_VDWXC_CHECK(nc_call) \
 ncerr = nc_call NEWLINE \
 if ( ncerr /= NF90_NOERR ) then NEWLINE \
  call vdw_df_netcdf_ioerr(ncerr,__FILE__,__LINE__) NEWLINE \
 end if
#else
#define NETCDF_VDWXC_CHECK(nc_call) \
 ncerr = nc_call NEWLINE \
 if ( ncerr /= NF90_NOERR ) then NEWLINE \
  call vdw_df_netcdf_ioerr(ncerr) NEWLINE \
 end if
#endif

#endif /* _ABINIT_XC_VDW_H */
